import java.util.Random;
import javax.microedition.lcdui.Graphics;

public class Block {
	public static final int Pattern0[][][] = {
			{ { 0, 0, 0, 0 }, { 0, 1, 1, 0 }, { 0, 1, 1, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 0, 0, 0 }, { 0, 1, 1, 0 }, { 0, 1, 1, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 0, 0, 0 }, { 0, 1, 1, 0 }, { 0, 1, 1, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 0, 0, 0 }, { 0, 1, 1, 0 }, { 0, 1, 1, 0 }, { 0, 0, 0, 0 } } };

	public static final int Pattern1[][][] = {
			{ { 0, 0, 1, 0 }, { 0, 0, 1, 0 }, { 0, 1, 1, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 0, 0, 0 }, { 0, 1, 0, 0 }, { 0, 1, 1, 1 }, { 0, 0, 0, 0 } },
			{ { 0, 0, 0, 0 }, { 0, 1, 1, 0 }, { 0, 1, 0, 0 }, { 0, 1, 0, 0 } },
			{ { 0, 0, 0, 0 }, { 1, 1, 1, 0 }, { 0, 0, 1, 0 }, { 0, 0, 0, 0 } } };

	public static final int Pattern2[][][] = {
			{ { 0, 1, 0, 0 }, { 0, 1, 0, 0 }, { 0, 1, 1, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 0, 0, 0 }, { 0, 1, 1, 1 }, { 0, 1, 0, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 0, 0, 0 }, { 0, 1, 1, 0 }, { 0, 0, 1, 0 }, { 0, 0, 1, 0 } },
			{ { 0, 0, 0, 0 }, { 0, 0, 1, 0 }, { 1, 1, 1, 0 }, { 0, 0, 0, 0 } } };

	public static final int Pattern3[][][] = {
			{ { 0, 0, 1, 0 }, { 0, 0, 1, 0 }, { 0, 0, 1, 0 }, { 0, 0, 1, 0 } },
			{ { 0, 0, 0, 0 }, { 0, 0, 0, 0 }, { 1, 1, 1, 1 }, { 0, 0, 0, 0 } },
			{ { 0, 0, 1, 0 }, { 0, 0, 1, 0 }, { 0, 0, 1, 0 }, { 0, 0, 1, 0 } },
			{ { 0, 0, 0, 0 }, { 0, 0, 0, 0 }, { 1, 1, 1, 1 }, { 0, 0, 0, 0 } } };

	public static final int Pattern4[][][] = {
			{ { 0, 0, 0, 0 }, { 1, 1, 0, 0 }, { 0, 1, 1, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 0, 1, 0 }, { 0, 1, 1, 0 }, { 0, 1, 0, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 0, 0, 0 }, { 1, 1, 0, 0 }, { 0, 1, 1, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 0, 1, 0 }, { 0, 1, 1, 0 }, { 0, 1, 0, 0 }, { 0, 0, 0, 0 } } };

	public static final int Pattern5[][][] = {
			{ { 0, 0, 0, 0 }, { 0, 1, 1, 0 }, { 1, 1, 0, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 1, 0, 0 }, { 0, 1, 1, 0 }, { 0, 0, 1, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 0, 0, 0 }, { 0, 1, 1, 0 }, { 1, 1, 0, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 1, 0, 0 }, { 0, 1, 1, 0 }, { 0, 0, 1, 0 }, { 0, 0, 0, 0 } } };

	public static final int Pattern6[][][] = {
			{ { 0, 0, 0, 0 }, { 1, 1, 1, 0 }, { 0, 1, 0, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 1, 0, 0 }, { 1, 1, 0, 0 }, { 0, 1, 0, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 1, 0, 0 }, { 1, 1, 1, 0 }, { 0, 0, 0, 0 }, { 0, 0, 0, 0 } },
			{ { 0, 1, 0, 0 }, { 0, 1, 1, 0 }, { 0, 1, 0, 0 }, { 0, 0, 0, 0 } } };
	
	public static final int[][][][] Patterns = { Pattern0, Pattern1, Pattern2, Pattern3, Pattern4, Pattern5, Pattern6 };

	public static final int[] Colors = {0x00FF0000, 0x00FF7D00, 0x00FFFF00, 0x0000FF00, 0x000000FF, 0x0000FFFF, 0x00FF00FF};
	
	private static final int GridWidth = GameCanvas.GridWidth;
	private static final int GridHeight = GameCanvas.GridHeight;
	public static final Random random = new Random();
	
	public static boolean IsColorSimilar(int colorA, int colorB){
		int diffR = Math.abs((colorA & 0x00FF0000) - (colorB & 0x00FF0000));
		int diffG = Math.abs((colorA & 0x0000FF00) - (colorB & 0x0000FF00));
		int diffB = Math.abs((colorA & 0x000000FF) - (colorB & 0x000000FF));
		return (diffR + diffG + diffB) < 100;
	}
	
	public int Type;
	public int Rotate;
	public int StartX;
	public int StartY;
	public int Color;
	
	private Block(){} //for clone function use only
	
	public Block(int type) {
		Type = type % Patterns.length;
		Rotate = 0;
		StartX = GridWidth / 2 - 2;
		StartY = -4;
		Color = Colors[Type];
//		Color = random.nextInt(0x00FFFFFF);
//		while (IsColorSimilar(Color, GameCanvas.BackgroundColor)
//				|| IsColorSimilar(Color, GameCanvas.GridColor)
//				|| IsColorSimilar(Color, GameCanvas.BlockDownTipsColor))
//			Color = random.nextInt(0x00FFFFFF);
	}
	
	public Block Clone(){
		Block block = new Block();
		block.Type = Type;
		block.Rotate = Rotate;
		block.StartX = StartX;
		block.StartY = StartY;
		block.Color = Color;
		return block;
	}
	
	public static Block CreateRandomBlock(){
		int t = random.nextInt(Patterns.length);
		return new Block(t);
	}
	
	public boolean moveLeft(int[][] grid){
		for(int i=0; i<4; i++)
			for(int j=0; j<4; j++){				
				if(Patterns[Type][Rotate][i][j] <= 0) continue;
				int x = StartX + i - 1;
				int y = StartY + j;
				if(x < 0 || x >= GridWidth || y >= GridHeight || (y >= 0 && grid[x][y] > 0))
					return false;
			}
		StartX -= 1;
		return true;
	}
	
	public boolean moveRight(int[][] grid){
		for(int i=0; i<4; i++)
			for(int j=0; j<4; j++){				
				if(Patterns[Type][Rotate][i][j] <= 0) continue;
				int x = StartX + i + 1;
				int y = StartY + j;
				if(x < 0 || x >= GridWidth || y >= GridHeight || (y >= 0 && grid[x][y] > 0))
					return false;
			}
		StartX += 1;
		return true;
	}
	
	public boolean moveDown(int[][] grid){
		for(int i=0; i<4; i++)
			for(int j=0; j<4; j++){
				if(Patterns[Type][Rotate][i][j] <= 0) continue;
				int x = StartX + i;
				int y = StartY + j + 1;
				if(x < 0 || x >= GridWidth || y >= GridHeight || (y >= 0 && grid[x][y] > 0))
					return false;
			}
		StartY += 1;
		return true;
	}
	
	public int moveBottom(int[][] grid){
		int minDepth = GridHeight+6;
		for(int i=0; i<4; i++)
			for(int j=3; j>=0; j--){
				if(Patterns[Type][Rotate][i][j] <= 0) continue;
				int x = StartX + i;
				int y = Math.max(0, StartY + j + 1);
				while(y < GridHeight && grid[x][y] <= 0) y++;
				int depth = y - StartY - j - 1;
				if(minDepth > depth) minDepth = depth;
			}
		StartY += minDepth;
		return minDepth;
	}
	
	public boolean rotate(int[][] grid){
		int rotate = (Rotate + 1) % 4;
		for(int i=0; i<4; i++)
			for(int j=0; j<4; j++){				
				if(Patterns[Type][rotate][i][j] <= 0) continue;
				int x = StartX + i;
				int y = StartY + j;
				if(x < 0 || x >= GridWidth || y >= GridHeight || (y >= 0 && grid[x][y] > 0))
					return false;
			}
		Rotate = (Rotate + 1) % 4;
		return true;
	}

	public void paint(Graphics g, int x, int y, int width, int height){
		g.setColor(Color);
		for(int i=0; i<4; i++)
			for(int j=0; j<4; j++){
				if(Patterns[Type][Rotate][i][j] == 0) continue;
				g.fillRect(x + i*width/4, y + j*height/4, width/4, height/4);
			}
	}

	public void paintInGameCanvaGrid(Graphics g, int gridStartX, int gridStartY, int gridWidth, int gridHeight){
		for(int i=0; i<4; i++){
			for(int j=0; j<4; j++){
				if(Block.Patterns[Type][Rotate][i][j] <= 0) continue;
				int gridX = StartX + i;
				int gridY = StartY + j;
				if(gridX < 0 || gridX >= GridWidth || gridY < 0 || gridY >= GridHeight) continue;
				g.setColor(Color);
				g.fillRect(gridStartX+gridX*gridWidth, gridStartY+gridY*gridHeight, gridWidth, gridHeight);
			}
		}
	}
}
